package fumdb;

import java.sql.Date;
import java.sql.SQLException;
import java.util.Iterator;
import java.util.Map;
import java.util.Vector;

import fumdb.domain.Musician;
import fumdb.domain.Person;
import fumdb.domain.Record;
import fumdb.domain.Song;
import fumdb.sql.Persistence;
import fumdb.sql.SQLErrorListener;

/**
 * @author Richard Cyganiak
 */
public class SqlTest {

	public static void dumpMap(Map map) {
		Iterator it = map.keySet().iterator();
		while (it.hasNext()) {
			Object o = it.next();
			System.out.println(o + " => " + map.get(o));
		}
	}

	public static void dumpVector(Vector vector) {
		Iterator it = vector.iterator();
		while (it.hasNext()) {
			System.out.println(it.next());
		}
	}

	public static void main(String[] args) {
		Persistence db;
		try {
			System.out.println("Connecting to Oracle...");
			db = new Persistence(new SimpleErrorListener());
			db.connect();
			System.out.println("OK");

			Musician musician = db.getMusicianByName("everything");
			Record record = (Record) db.getSimilarRecords("surrender").get(0);
//			Song song = new Song(db, musician);
//			song.setName("Name");
//			song.setGenreName("Brit Pop");
//			song.commit();
			
			dumpVector(db.getSongsByMusician(musician.getId()));
//			dumpVector(db.getMusiciansByGenre("Big Beat"));
//			dumpMap(db.getSongCountsByGenre());
			
//			dumpMap(db.getRecordsByGenre("Brit Pop"));
/*
			Person p = new Person(db);
			p.setFirstName("Richard");
			p.setLastName("Cyganiak");
			p.setMale(true);
			System.out.println(p.commit());

			dumpVector(db.getAllMusicians());
*/
//			Musician musician = db.getMusicianByName("everything");
//			Record record = new Record(db, musician);
//			record.setTitle("bla");
//			record.setRecordCompany("Virgin");
//			record.setPublishedDate(Date.valueOf("1999-06-18"));
//			record.commit();
			
//			dumpVector(db.getAllRecords());
/*
			Vector v = db.getMusiciansByName("RO");
			Iterator it = v.iterator();
			while (it.hasNext()) {
				System.out.println(it.next());
			}
*/
/*
			Person p = (Person) db.getMusician(31);
			Vector v = p.getBandMemberships();
			System.out.println(v.size());
			System.out.println(v.get(0));
			System.out.println(v.get(1));
			Member m = (Member) v.get(0);
			System.out.println(m.getBand().getName());
			System.out.println(m.getPerson());
*/
//			int rowCount = db.getRecordCount();
//			System.out.println("row count on Tontraeger: " + rowCount);
//			for (int i = 1; i <= rowCount; i++) {
//				System.out.println(db.readRecord(i));
//			}
/*
			Vector records = db.getAllRecords();
			Iterator it = records.iterator();
			while (it.hasNext()) {
				Record each = (Record) it.next();
				System.out.println(each);
			}

			it = records.iterator();
			while (it.hasNext()) {
				Record each = (Record) it.next();
				Musician musician = db.getMusician(each.getMusicianID());
				System.out.println(musician);
			}
*/
		} catch (ClassNotFoundException e) {
			System.err.println("Unable to locate Oracle driver");
			System.err.println("Please make sure that oracle.jdbc.driver.OracleDriver is on the CLASSPATH!");
		} catch (SQLException e) {
			System.err.println("Unable to connect to database");
			System.err.println("Reported error: " + e.getMessage());
		}
		System.out.println("Finishing now");
	}
}

class SimpleErrorListener implements SQLErrorListener {
	public void catchSQLException(SQLException e) {
		e.printStackTrace();
		System.exit(1);
	}
}