package fumdb.domain;

import java.security.Permission;
import java.util.Vector;

import fumdb.sql.Persistence;

/**
 * @author Richard Cyganiak
 */
public class Band extends Musician {

	private String name;

	public Band(Persistence persistence, int id) {
		super(persistence, id);
	}

	public Band(Persistence persistence) {
		this(persistence, NO_ID);
	}

	/**
	 * @see fumdb.domain.Musician#getName()
	 */
	public String getName() {
		return name;
	}

	/**
	 * @see fumdb.domain.Musician#isBand()
	 */
	public boolean isBand() {
		return true;
	}

	public void setName(String name) {
		this.name = name;
	}
	
	public String toString() {
		String result = (getId() == NO_ID) ? "[unknown band] " : "[band " + getId() + "] ";
		result += name;
		return result;
	}
	
	public Vector getMembers() {
		return getPersistence().getBandMembers(getId());
	}

	protected boolean update() {
		return getPersistence().updateBand(this);
	}
	
	protected boolean create() {
		return super.create(getPersistence().createBand(this));
	}
}
