package fumdb.domain;

import java.util.Vector;

/**
 * @author Richard Cyganiak
 */
public class Genre {

	private String name;
	private Genre parent;
	private Genres tree;
	
	public Genre(Genres tree, String name, Genre parent) {
		this.tree = tree;
		this.name = name;
		this.parent = parent;
	}
	
	public String getName() {
		return name;
	}
	
	public Genre getParent() {
		return parent;
	}
	
	public boolean isTopLevelGenre() {
		return (parent == null);
	}
	
	public Vector getSubGenres() {
		return tree.getSubGenres(this);
	}
	
	public int getLevel() {
		return (parent == null) ? 0 : parent.getLevel() + 1;
	}
}