package fumdb.domain;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Vector;

import fumdb.sql.Persistence;

/**
 * @author Richard Cyganiak
 */
public class Genres extends PersistentData {

	private Map genres = new HashMap();

	public Genres(Persistence persistence, Map namesAndParents) {
		super(persistence);
		buildGenres(namesAndParents);
	}
	
	private void buildGenres(Map namesAndParents) {
		Iterator it = namesAndParents.keySet().iterator();
		while (it.hasNext()) {
			String each = (String) it.next();
			createGenre(each, namesAndParents);
		}
	}
	
	private Genre createGenre(String genre, Map namesAndParents) {
		if (genre == null) return null;
		if (genres.get(genre) != null) {
			return (Genre) genres.get(genre);
		}
		Genre parent = createGenre((String) namesAndParents.get(genre), namesAndParents);
		Genre result = new Genre(this, genre, parent);
		genres.put(genre, result);
		return result;
	}
	
	public Vector getSubGenres(Genre genre) {
		Vector result = new Vector();
		Iterator it = genres.values().iterator();
		while (it.hasNext()) {
			Genre each = (Genre) it.next();
			if (each.getParent() == genre) {
				result.add(each);
			}
		}
		return result;
	}
	
	public Genre get(String name) {
		return (Genre) genres.get(name);
	}
	
	public Vector getTopGenres() {
		return getSubGenres(null);
	}

	public Vector getAll() {
		return new Vector(genres.values());
	}
}