package fumdb.domain;

import java.sql.Date;

import fumdb.sql.Persistence;

/**
 * @author Richard Cyganiak
 */
public class Member extends PersistentData {

	private int personId;
	private int bandId;
	private String instrument;
	private Date startDate;
	private Date endDate;

	public Member(Persistence persistence, int personID, int bandID) {
		super(persistence);
		this.personId = personID;
		this.bandId = bandID;
	}
	
	public Member(Persistence persistence, Person person, Band band) {
		this(persistence, person.getId(), band.getId());
	}
	
	public int getPersonId() {
		return personId;
	}
	
	public int getBandId() {
		return bandId;
	}

	public Date getEndDate() {
		return endDate;
	}

	public String getInstrument() {
		return instrument;
	}

	public Date getStartDate() {
		return startDate;
	}

	public void setEndDate(Date endDate) {
		this.endDate = endDate;
	}

	public void setInstrument(String instrument) {
		this.instrument = instrument;
	}

	public void setStartDate(Date startDate) {
		this.startDate = startDate;
	}
	
	public Band getBand() {
		return (Band) getPersistence().getMusician(getBandId());
	}
	
	public Person getPerson() {
		return (Person) getPersistence().getMusician(getPersonId());
	}
	
	public String toString() {
		return "[member] person: " + personId + ", band: " + bandId + ", instrument '" + instrument + "'";
	}
}
