package fumdb.domain;

import java.util.Vector;

import fumdb.sql.Persistence;

/**
 * @author Richard Cyganiak
 */
public abstract class Musician extends PersistentData {

	public static final int NO_ID = 0;

	private int id;
	private String url;

	public Musician(Persistence persistence, int id) {
		super(persistence);
		this.id = id;
	}

	public abstract String getName();
	public abstract boolean isBand();

	public int getId() {
		return id;
	}
	
	public String getURL() {
		return url;
	}
	
	public void setURL(String url) {
		this.url = url;
	}

	public Vector getRecords() {
		return getPersistence().getRecordsByMusician(getId());
	}
	
	public boolean delete() {
		return getPersistence().deleteMusician(getId());
	}
	
	protected boolean create(int newId) {
		if (newId == NO_ID) {
			return false;
		}
		this.id = newId;
		return true;
	}

	public boolean isNew() {
		return getId() == NO_ID;
	}
}