package fumdb.gui;

import java.awt.Color;
import java.awt.Component;

import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.ListCellRenderer;

import fumdb.FUMuDB;

/**
 * @author anja
 */
public class FUMuDBListRenderer extends JLabel implements ListCellRenderer {
	public JList jList;
	public FuMuDbGUI gui;
	ImageIcon song = new ImageIcon(getClass().getResource("song_icon.gif").getFile());
	ImageIcon record = new ImageIcon(getClass().getResource("record_icon.gif").getFile());
	ImageIcon artist = new ImageIcon(getClass().getResource("artist_icon.gif").getFile());
	ImageIcon query = new ImageIcon(getClass().getResource("query_icon.gif").getFile());
	ImageIcon search = new ImageIcon(getClass().getResource("search_icon.gif").getFile());

	ImageIcon song_new = new ImageIcon(getClass().getResource("song_icon_add.gif").getFile());
	ImageIcon record_new = new ImageIcon(getClass().getResource("record_icon_add.gif").getFile());
	ImageIcon artist_new = new ImageIcon(getClass().getResource("artist_icon_add.gif").getFile());

	public FUMuDBListRenderer(JList jList, FuMuDbGUI gui) {
		setOpaque(true);
		this.jList = jList;
		this.gui = gui;
    }
    
    public Component getListCellRendererComponent(JList list, Object value, int index, 
			boolean isSelected, boolean cellHasFocus) {
		if(jList.isSelectedIndex(index)) {
			setBackground(new Color(113,196,249));
			setForeground(Color.white);
		} else {
			setBackground(Color.white);
			setForeground(Color.black);
		}
		setText(value.toString());

		if (value.toString().indexOf("neu") != -1) {
			if (value.toString().indexOf("Tontrger") != -1) {
				setIcon(record_new);
			}
			if (value.toString().indexOf("Musiker") != -1) {
				setIcon(artist_new);
			}
			if (value.toString().indexOf("Band") != -1) {
				setIcon(artist_new);
			}
			if (value.toString().indexOf("Song") != -1) {
				setIcon(song_new);
			}
		} else {
			if (value.toString().indexOf("Tontrger") != -1) {
				setIcon(record);
			}
			if (value.toString().indexOf("Musiker") != -1) {
				setIcon(artist);
			}
			if (value.toString().indexOf("Band") != -1) {
				setIcon(artist);
			}
			if (value.toString().indexOf("Song") != -1) {
				setIcon(song);
			}
			if (value.toString().indexOf("Suche") != -1) {
				setIcon(search);
			}
		}
		
		return this;
	}

}