package fumdb.gui;

import java.awt.Component;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Vector;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;

/**
 * @author anja
 */
public class FormSearch extends JDialog implements ActionListener {
	FuMuDbGUI gui;
	GridBagLayout gridbag;
	JPanel screenPanel = new JPanel();
	
	JLabel label1 = new JLabel("Suche alle");
	String[] searchEntity = {"Musiker", "Tontrger"};
	JComboBox comboEntity;
	JLabel label2 = new JLabel("in denen");
	JTextField searchField = new JTextField(20);
	JLabel label3 = new JLabel("enthalten ist.");
	JButton buttonSearch = new JButton("suchen");

	public FormSearch(FuMuDbGUI frame, String title, boolean modal) {
		super(frame, title, modal);
		gui = frame;
		
		buttonSearch.addActionListener(this);
		
		comboEntity = new JComboBox(searchEntity);
		comboEntity.setSelectedIndex(0);
		
		gridbag = new GridBagLayout();
		GridBagConstraints gbc = new GridBagConstraints();
		screenPanel.setLayout(gridbag);
		gbc.weightx = 0;
		gbc.weighty = 0.5;
		
		searchField.setPreferredSize(new Dimension(100, 22));
		searchField.setMinimumSize(new Dimension(100, 22));
		
		addToGBL(label1, 0, 1, 1, 1, GridBagConstraints.HORIZONTAL);
		addToGBL(comboEntity, 1, 1, 1, 1, GridBagConstraints.HORIZONTAL);
		addToGBL(label2, 2, 1, 1, 1, GridBagConstraints.HORIZONTAL);
		addToGBL(searchField, 3, 1, 1, 1, GridBagConstraints.HORIZONTAL);
		addToGBL(label3, 4, 1, 1, 1, GridBagConstraints.HORIZONTAL);

		addToGBL(buttonSearch, 4, 2, 1, 1, GridBagConstraints.HORIZONTAL);

		getContentPane().add(screenPanel);
		
		Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
		this.setSize(new Dimension(500, 150));
		this.setLocation((screenSize.width - 500)/2,(screenSize.height - 150)/2);
		this.setVisible(true);
		this.setResizable(false);
		this.validate();
	}

	
	public void addToGBL(Component c, int x, int y, 
			int width, int height, int fill) {
		GridBagConstraints gbc = new GridBagConstraints();
		gbc.gridy = y;
		gbc.gridx = x;		
		gbc.gridwidth = width;
		gbc.gridheight = height;
		gbc.insets = new Insets(0,0,4,10);
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gridbag.setConstraints(c, gbc);
		screenPanel.add(c);
	}

	public void actionPerformed(ActionEvent e) {
		if (e.getSource() == buttonSearch) {
			if (!searchField.getText().equals("")) {
				if (comboEntity.getSelectedIndex() == 0) {
					Vector musicians = gui.getPersistence().getSimilarMusicians(searchField.getText());
					if (musicians.size()>0) {
						ListViewMusician frame = new ListViewMusician(gui, gui.getDesktopDimension(), "gefundene Bands und Musiker mit '"+searchField.getText()+"'", musicians); 
						gui.addInternalFrameToVector(frame,"gefundene Musiker");
						this.dispose();
					} else {
						JOptionPane.showMessageDialog(this, "Suche war nicht erfolgreich");
					} 				
				} else {
					Vector records = gui.getPersistence().getSimilarRecords(searchField.getText());
					if (records.size()>0) {
						ListViewRecord frame = new ListViewRecord(gui, gui.getDesktopDimension(), "gefundene Tontrger mit '"+searchField.getText()+"'", records); 
						gui.addInternalFrameToVector(frame,"gefundene Tontrger");
						this.dispose();
					} else {
						JOptionPane.showMessageDialog(this, "Suche war nicht erfolgreich");
					} 				
				}
			}
		}
	}
}
