package fumdb.gui;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusAdapter;
import java.awt.event.FocusEvent;
import java.sql.Date;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.ListSelectionModel;
import javax.swing.border.Border;
import javax.swing.event.InternalFrameAdapter;
import javax.swing.event.InternalFrameEvent;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.TableColumn;

import fumdb.domain.Musician;
import fumdb.domain.Record;
import fumdb.domain.RecordCompany;
import fumdb.domain.Song;
import fumdb.domain.Tracklist;

/**
 * @author anja
 */

public class FormViewRecord extends FormView implements ActionListener {
	FuMuDbGUI gui;
	Record record = null;
	int recordID = -1;
	int musicianID = 0;
	
	JScrollPane scrollPane;
	JPanel form = new JPanel();
	JPanel trackPanel = new JPanel();
	GridBagLayout gridbag;
	JLabel label1a = new JLabel("");
	JLabel label1b = new JLabel("");
	JLabel label2a = new JLabel("");
	JLabel label2b = new JLabel("");
	JLabel label3a = new JLabel("");
	JLabel label3b = new JLabel("");
	JLabel label4a = new JLabel("");
	JLabel label4b = new JLabel("");
	JLabel label5a = new JLabel("");
	JLabel label5b = new JLabel("");
			
	JLabel labelTitle = new JLabel("Titel : ");
	JLabel labelArtist = new JLabel("Musiker : ");
	JPanel musicianInfoPanel = new JPanel();
	JLabel labelReleaseDate = new JLabel("Erscheinungsdatum : ");
	JLabel labelRecordCompany = new JLabel("Plattenfirma : ");
	JLabel labelSongs = new JLabel("Songs : ");
	JLabel labelCompilation = new JLabel("Compilation");

	JTextField fieldTitle = new JTextField(25);
	JTextField fieldArtist = new JTextField(25);
	JTextField fieldReleaseDay = new JTextField(2);
	JTextField fieldReleaseMonth = new JTextField(2);
	JTextField fieldReleaseYear = new JTextField(4);

	JButton buttonChooseArtist = new JButton("...");
	JButton buttonAddFunctions = new JButton("Funktionen hinzufgen");
	JButton buttonDeleteRecord = new JButton("Tontrger lschen");
	JButton buttonAddRecord = new JButton("Tontrger speichern");
	JButton buttonDoNothing = new JButton("");

	JComboBox fieldRecordCompilation;
	JComboBox companyList;
	
	JCheckBox comboCompilation = new JCheckBox("Compilation");
	
	String[] recordCompanies;
	String recordCompany = "";

	String[] songsOnRecord;
	String[] songsLength;
	
	FuMuDbTableModel trackModel = new FuMuDbTableModel(new int[] {1, 2});
	JTable trackTable = new JTable(trackModel);
	
	public FormViewRecord(FuMuDbGUI gui, Dimension size, String title) {
		super(size, title);
		this.gui = gui;

		createFrame();
		createInfoPanel();
		label1a.setText("Keine Informationen zum Musiker vorhanden.");
		createForm();
	}
	
	public FormViewRecord(FuMuDbGUI gui, String recordTitle, Record record) {
		super(gui.getDesktopDimension(), "Tontrger : "+recordTitle);
		this.gui = gui;
		this.record = record;
		recordID = record.getId();

		createFrame();

		fieldTitle.setText(record.getTitle());
		if (record.hasMainArtist()) {
			fieldArtist.setText(record.getMusicianName());
		}
		if (record.getPublishedDate() != null) {
			fieldReleaseYear.setText(record.getPublishedDate().toString().substring(0,4));
			fieldReleaseMonth.setText(record.getPublishedDate().toString().substring(5,7));
			fieldReleaseDay.setText(record.getPublishedDate().toString().substring(8,10));
		}
		if (!record.hasMainArtist()) {
			comboCompilation.setSelected(true);
		}
		recordCompany = record.getRecordCompanyName();
		
		Tracklist songs = record.getTracklist();
		songsOnRecord = new String[songs.size()];
		songsLength = new String[songs.size()];
		for (int i=1; i<=songsOnRecord.length; i++) {
			songsOnRecord[i-1] = songs.getSong(i).getName();
			songsLength[i-1] = getTrackLength(songs.getLength(i));
		}

		createInfoPanel();
		if (record.hasMainArtist()) {
			MusicianInfoPanel infoPanel2 = new MusicianInfoPanel(gui, this, record.getMusician().getId());
		}
		
		createForm();
	}

	public void createInfoPanel() {
		gridbag = new GridBagLayout();
		GridBagConstraints gbc = new GridBagConstraints();
		musicianInfoPanel.setLayout(gridbag);
		gbc.weightx = 0;
		gbc.weighty = 0.5;
		
		Border blackline = BorderFactory.createEtchedBorder();
		musicianInfoPanel.setBorder(blackline);
		
		addToGBL(label1a, 0, 1, 1, 1, GridBagConstraints.HORIZONTAL);
		addToGBL(label1b, 1, 1, 1, 1, GridBagConstraints.HORIZONTAL);
		addToGBL(label2a, 0, 2, 1, 1, GridBagConstraints.HORIZONTAL);
		addToGBL(label2b, 1, 2, 1, 1, GridBagConstraints.HORIZONTAL);
		addToGBL(label3a, 0, 3, 1, 1, GridBagConstraints.HORIZONTAL);
		addToGBL(label3b, 1, 3, 1, 1, GridBagConstraints.HORIZONTAL);
		addToGBL(label4a, 0, 4, 1, 1, GridBagConstraints.HORIZONTAL);
		addToGBL(label4b, 1, 4, 1, 1, GridBagConstraints.HORIZONTAL);
		addToGBL(label5a, 0, 5, 1, 1, GridBagConstraints.HORIZONTAL);
		addToGBL(label5b, 1, 5, 1, 2, GridBagConstraints.HORIZONTAL);
	}
	
	public void createForm() {
 		this.addInternalFrameListener(new InternalFrameAdapter() {
			public void internalFrameClosed(InternalFrameEvent e) {
				gui.deleteInternalFrame(FormViewRecord.this);
			}
		});

		trackModel.setColumnEditableAndShowable(2, true);
		
		Vector recordCompaniesVec = gui.getPersistence().getRecordCompanies();
		recordCompanies = new String[recordCompaniesVec.size()];
		for (int i=0; i<recordCompaniesVec.size(); i++) {
			recordCompanies[i] = ((RecordCompany) recordCompaniesVec.get(i)).getName();
		}
		companyList = new JComboBox(recordCompanies);
		companyList.setSelectedItem(recordCompany);

		Border blackline = BorderFactory.createEtchedBorder();
		musicianInfoPanel.setBorder(blackline);

		trackModel.addColumn("Nr");
		trackModel.addColumn("Titel");
		trackModel.addColumn("Lnge (mm:ss)");
		trackModel.addColumn("Knstler");
		trackTable.getTableHeader().setReorderingAllowed(false);
	    trackTable.getTableHeader().setResizingAllowed(false);
		trackTable.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

		TableColumn col0 = trackTable.getColumnModel().getColumn(0);
		col0.setMinWidth(30);
		col0.setMaxWidth(30);
		col0.setPreferredWidth(30);

		TableColumn col1 = trackTable.getColumnModel().getColumn(1);
		col1.setMinWidth(250);
		col1.setMaxWidth(250);
		col1.setPreferredWidth(250);

		TableColumn col2 = trackTable.getColumnModel().getColumn(2);
		col2.setMinWidth(70);
		col2.setMaxWidth(70);
		col2.setPreferredWidth(70);

		TableColumn col3 = trackTable.getColumnModel().getColumn(3);
		col3.setMinWidth(170);
		col3.setMaxWidth(170);
		col3.setPreferredWidth(170);

		int j = 20;
		if (songsOnRecord != null) {
			if (songsOnRecord.length>0) {
				j = songsOnRecord.length;
			}
		}
		for (int i=0; i<j; i++) {
			if (songsOnRecord != null) {
				if (songsOnRecord.length>i) {
					if (songsOnRecord[i] != null) {
						trackModel.addRow(new Object[]{new Integer(i+1),songsOnRecord[i], songsLength[i], ""});
					} else {
						trackModel.addRow(new Object[]{new Integer(i+1), "", "", ""});
					}
				} else {
					trackModel.addRow(new Object[]{new Integer(i+1), "", "", ""});
				}
			} else {
				trackModel.addRow(new Object[]{new Integer(i+1), "", "", ""});
			}
		}
		trackModel.addRow(new Object[]{new Integer(j+1), "", "", ""});
		
		trackTable.getColumnModel().getColumn(trackModel.getColumnCount()-1).setCellRenderer(new FuMuDbTableCellRenderer());
		
		setCompilation();
		
		fieldArtist.addFocusListener(new FocusAdapter() {
			public void focusLost(FocusEvent e) {
				if (fieldArtist.getText() != "") {
					lookUpMusician();
				}
			}
		});
		
		comboCompilation.addActionListener(this);
		buttonChooseArtist.addActionListener(this);
		buttonAddFunctions.addActionListener(this);
		buttonDeleteRecord.addActionListener(this);
		buttonAddRecord.addActionListener(this);
		
		GridBagLayout gridbag = new GridBagLayout();
		GridBagConstraints gbc = new GridBagConstraints();
		form.setLayout(gridbag);
		
		gbc.weightx = 0;
		gbc.weighty = 0.5;
		
		companyList.setMinimumSize(new Dimension(340, 24));
		companyList.setPreferredSize(new Dimension(340, 24));
		
		addToGBL(form, gridbag, labelTitle, 0, 1, 1, 1, GridBagConstraints.HORIZONTAL);
		addToGBL(form, gridbag, fieldTitle, 1, 1, 5, 1, GridBagConstraints.HORIZONTAL);

		addToGBL(form, gridbag, labelArtist, 0, 2, 1, 1, GridBagConstraints.HORIZONTAL);
		addToGBL(form, gridbag, fieldArtist, 1, 2, 5, 1, GridBagConstraints.HORIZONTAL);
		addToGBL(form, gridbag, buttonChooseArtist, 6, 2, 1, 1, GridBagConstraints.HORIZONTAL);

		addToGBL(form, gridbag, musicianInfoPanel, 1, 3, 6, 1, GridBagConstraints.HORIZONTAL);

		fieldReleaseDay.setMinimumSize(new Dimension(24, 22));
		fieldReleaseDay.setPreferredSize(new Dimension(24, 22));
		fieldReleaseMonth.setMinimumSize(new Dimension(24, 22));
		fieldReleaseMonth.setPreferredSize(new Dimension(24, 22));
		fieldReleaseYear.setMinimumSize(new Dimension(40, 22));
		fieldReleaseYear.setPreferredSize(new Dimension(40, 22));

		addToGBL(form, gridbag, labelReleaseDate, 0, 4, 1, 1, GridBagConstraints.HORIZONTAL);
		addToGBL(form, gridbag, fieldReleaseDay, 1, 4, 1, 1, GridBagConstraints.HORIZONTAL);
		addToGBL(form, gridbag, fieldReleaseMonth, 2, 4, 1, 1, GridBagConstraints.HORIZONTAL);
		addToGBL(form, gridbag, fieldReleaseYear, 3, 4, 1, 1, GridBagConstraints.HORIZONTAL);

		addToGBL(form, gridbag, labelRecordCompany, 0, 5, 1, 1, GridBagConstraints.HORIZONTAL);
		addToGBL(form, gridbag, companyList, 1, 5, 4, 1, GridBagConstraints.HORIZONTAL);
        
        trackPanel.setLayout(new BorderLayout());
        trackPanel.add(trackTable, BorderLayout.CENTER);
        scrollPane = new JScrollPane(trackPanel);
		scrollPane.setPreferredSize(new Dimension(520, 170));
		scrollPane.setMinimumSize(new Dimension(520, 170));
		scrollPane.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
        
             
		addToGBL(form, gridbag, labelSongs, 0, 6, 1, 1, GridBagConstraints.HORIZONTAL);
		addToGBL(form, gridbag, trackTable.getTableHeader(), 1, 6, 6, 1, GridBagConstraints.HORIZONTAL);
		addToGBL(form, gridbag, scrollPane, 1, 7, 6, 10, GridBagConstraints.HORIZONTAL);
		
		addToGBL(form, gridbag, buttonAddFunctions, 6, 17, 1, 1, GridBagConstraints.HORIZONTAL);
             
		addToGBL(form, gridbag, comboCompilation, 0, 17, 1, 1, GridBagConstraints.HORIZONTAL);
		addToGBL(form, gridbag, buttonDeleteRecord, 6, 18, 1, 1, GridBagConstraints.HORIZONTAL);
		addToGBL(form, gridbag, buttonAddRecord, 6, 19, 1, 1, GridBagConstraints.HORIZONTAL);

		getContentPane().add(form);
	}
	
	public void actionPerformed(ActionEvent e) {
		if (e.getSource() == comboCompilation) {
			setCompilation();
			repaint();
			return;
		}
		if (e.getSource() == buttonDeleteRecord) {
			if (record != null) {
				boolean deleted = record.delete();
				if (deleted) {
					this.dispose();
					gui.deleteInternalFrame(this);
				}
			}
		}
		if (e.getSource() == buttonAddRecord) {
			if (!fieldTitle.getText().equals("")) {
				if (record == null) {
					Musician musician = gui.getPersistence().getMusician(musicianID);
					if (musician != null/* && !comboCompilation.isSelected()*/) {
	//						if (comboCompilation.isSelected()) {
	//							record = new Record(gui.getPersistence());
	//						} else {
								record = new Record(gui.getPersistence(), musician);
	//						}
						if (!fieldReleaseYear.getText().equals("")) {
							try {
								if (fieldReleaseDay.getText().equals("")) {
									fieldReleaseDay.setText("01");
								}	
								if (fieldReleaseMonth.getText().equals("")) {
									fieldReleaseMonth.setText("01");
								}	
								Date releaseDate = Date.valueOf(fieldReleaseYear.getText()+"-"+fieldReleaseMonth.getText()+"-"+fieldReleaseDay.getText());
								record.setPublishedDate(releaseDate);
							} catch (IllegalArgumentException exc) {
								JOptionPane.showMessageDialog(this, "Falsches Datumsformat. Richtiges Format : DD MM YYYY");
							}
						}
	
						record.setTitle(fieldTitle.getText());
						record.setMusician(musician.getId(), musician.getName());
		
						record.setRecordCompany((String) companyList.getSelectedItem());
						Tracklist tracklist = record.getTracklist();
						
						int trackCount = 0;
						while (!trackModel.getValueAt(trackCount, 1).toString().equals("")) {
							Song song = new Song(gui.getPersistence(), musician);
							song.setName(trackModel.getValueAt(trackCount, 1).toString());
							boolean commited = song.commit();
							if (!commited) {
								JOptionPane.showMessageDialog(this, "Fehler beim Speichern der Songs aufgetreten");
								return;
							}
							String lengthString = trackModel.getValueAt(trackCount, 2).toString();
							int length = getTrackLength(lengthString);
							tracklist.addSong(trackCount+1, song, length);
							trackCount++;
						}
						boolean commited = record.commit();
						if (commited) {
							this.dispose();
							gui.deleteInternalFrame(this);
						}
					} else {
						JOptionPane.showMessageDialog(this, "Musiker/Band nicht bekannt. Bitte erst anlegen!");
					}
				} else {
					Musician musician = record.getMusician();
					if (!fieldReleaseYear.getText().equals("")) {
						try {
							if (fieldReleaseDay.getText().equals("")) {
								fieldReleaseDay.setText("01");
							}	
							if (fieldReleaseMonth.getText().equals("")) {
								fieldReleaseMonth.setText("01");
							}	
							Date releaseDate = Date.valueOf(fieldReleaseYear.getText()+"-"+fieldReleaseMonth.getText()+"-"+fieldReleaseDay.getText());
							record.setPublishedDate(releaseDate);
						} catch (IllegalArgumentException exc) {
							JOptionPane.showMessageDialog(this, "Falsches Datumsformat. Richtiges Format : DD MM YYYY");
						}
					}

					record.setTitle(fieldTitle.getText());
					record.setMusician(musician.getId(), musician.getName());
	
					record.setRecordCompany((String) companyList.getSelectedItem());
					Tracklist tracklist = record.getTracklist();

					int trackCount = 0;
					while (!trackModel.getValueAt(trackCount, 1).toString().equals("")) {
						Song song;
						if (tracklist.getSong(trackCount+1) == null) {
							song = new Song(gui.getPersistence(), musician);
						} else {
							song = tracklist.getSong(trackCount+1);
						}
						song.setName(trackModel.getValueAt(trackCount, 1).toString());
						boolean commited = song.commit();
						if (!commited) {
							return;
						}
						String lengthString = trackModel.getValueAt(trackCount, 2).toString();
						System.out.println("LengthString2: " + lengthString);
						int length = getTrackLength(lengthString);
						tracklist.addSong(trackCount+1, song, length);
						trackCount++;
					}
					boolean commited = record.commit();
					if (commited) {
						this.dispose();
						gui.deleteInternalFrame(this);
					}
				}					
			} else {
				JOptionPane.showMessageDialog(this, "Bitte Tontrgertitel eingeben.");
			}
			return;
		}
		if (e.getSource() == buttonChooseArtist) {
			ListDialog addBandDialog = new ListDialog(this, gui, "Band/Musiker auswhlen", true, gui.getPersistence().getAllBandNames(), gui.getPersistence().getAllMusicianNames() , gui.BANDS_MUSICIANS);
			return;
		}
		if (e.getSource() == buttonAddFunctions) {
// :TODO:
			return;
		}
	}

	public void setCompilation() {
		if (comboCompilation.isSelected()) {
		    trackTable.getColumnModel().getColumn(trackModel.getColumnCount()-1).setCellRenderer(new DefaultTableCellRenderer());
		    trackModel.setColumnEditableAndShowable(trackModel.getColumnCount()-1, true);
		} else {
		    trackTable.getColumnModel().getColumn(trackModel.getColumnCount()-1).setCellRenderer(new FuMuDbTableCellRenderer());
		    trackModel.setColumnEditableAndShowable(trackModel.getColumnCount()-1, false);
		}
	}
	
	public void lookUpMusician() {
		if (!fieldArtist.getText().equals("")) {
			Vector musicians = gui.getPersistence().getSimilarMusicians(fieldArtist.getText());
			if (musicians.size()>0) {
				MusicianInfoPanel infoPanel2 = new MusicianInfoPanel(gui, this, ((Musician) musicians.elementAt(0)).getId());
				fieldArtist.setText(((Musician) musicians.elementAt(0)).getName());
				musicianID = ((Musician) musicians.elementAt(0)).getId();
				repaint();
			} else {
				label1a.setText("Keine Informationen zum Musiker vorhanden.");
				label1b.setText("");
				label2a.setText("");
				label2b.setText("");
				label3a.setText("");
				label3b.setText("");
				label4a.setText("");
				label4b.setText("");
				label5a.setText("");
				label5b.setText("");
				repaint();
			}			
		}
	}

	public ImageIcon getIcon() {
		return new ImageIcon(getClass().getResource("record_icon_add.gif").getFile());
	}
	
	public String getTrackLength(int sec) {
		String minutes = "0";
		String secNull = "";
		int min = 0;
		if (sec/60>0) {
			min = sec/60;
			minutes = new Integer(min).toString();
		}
		sec = Math.abs(60*min-sec);
		if (sec<10) {
			secNull = "0";
		}
		return(minutes+":"+secNull+new Integer(sec).toString());
	}
	
	public int getTrackLength(String minSec) {
		int dPoint = minSec.indexOf(':');
		int sec = 0;
		if (dPoint == -1) {
			try {
				sec += Integer.parseInt(minSec);
			} catch (NumberFormatException e) {
				JOptionPane.showMessageDialog(this, "Falsches Tracklngen-Format, richtig : mm:ss");
			}
		} else {
			sec += Integer.parseInt(minSec.substring(dPoint+1, minSec.length()));
			sec += 60*(Integer.parseInt(minSec.substring(0, dPoint)));
		}
		return(sec);
	}

	public void addToGBL(Component c, int x, int y, 
			int width, int height, int fill) {
		GridBagConstraints gbc = new GridBagConstraints();
		gbc.gridy = y;
		gbc.gridx = x;		
		gbc.gridwidth = width;
		gbc.gridheight = height;
		gbc.insets = new Insets(0,0,4,10);
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gridbag.setConstraints(c, gbc);
		musicianInfoPanel.add(c);
	}
}
