package fumdb.gui;

import javax.swing.table.DefaultTableModel;

/**
 * @author jentzsch
 */

public class FuMuDbTableModel extends DefaultTableModel {
	int[] allowedColumns = new int[0];
	
	public FuMuDbTableModel() {}

	public FuMuDbTableModel(int[] allowedColumns) {
		this.allowedColumns = allowedColumns;
	}
	
	public boolean isCellEditable(int r, int c){
		for(int i=0; i < allowedColumns.length; i++) {
			if (c == allowedColumns[i]) {
				return true;
			}
		}
		return false;
	}

	public void setColumnEditableAndShowable(int c, boolean enable) {
		if (enable) {
			int[] temp = new int[allowedColumns.length+1];
			for (int i=0; i<allowedColumns.length; i++) {
				temp[i] = allowedColumns[i];
			}
			temp[temp.length-1] = c;
			allowedColumns = temp;
		} else {
			int[] temp = new int[allowedColumns.length-1];
			for (int i=0; i<allowedColumns.length-1; i++) {
				if (temp[i] != c) {
					temp[i] = allowedColumns[i];
				} else {
					i--;
				}
			}
			allowedColumns = temp;
		}
	}
}
