package fumdb.gui;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Frame;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.Iterator;
import java.util.Map;

import javax.swing.BorderFactory;
import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.ListSelectionModel;
import javax.swing.border.Border;

/**
 * @author anja
 */
public class ListDialog extends JDialog implements ActionListener {
	FuMuDbGUI gui;
	FormViewRecord formViewRecord = null;
	FormViewPerson formViewPerson = null;
	FormViewBand formViewBand = null;
	int type;
	
	GridBagLayout gridbag;
	Map map;
	JPanel screenPanel = new JPanel();
	JPanel lowerPanel = new JPanel();
	JPanel listPanel = new JPanel();
	JScrollPane scrollPane;
	JPanel infoPanel = new JPanel();
	JPanel buttonPanel = new JPanel();
	DefaultListModel listModel = new DefaultListModel();
	JList list = new JList(listModel);
	
	JButton button1 = new JButton("");
	JButton button2 = new JButton("");
	JButton button3 = new JButton("");
	
	JLabel label1a = new JLabel("");
	JLabel label1b = new JLabel("");
	JLabel label2a = new JLabel("");
	JLabel label2b = new JLabel("");
	JLabel label3a = new JLabel("");
	JLabel label3b = new JLabel("");
	JLabel label4a = new JLabel("");
	JLabel label4b = new JLabel("");
	JLabel label5a = new JLabel("");
	JLabel label5b = new JLabel("");
	
	public ListDialog(FormViewPerson formViewPerson, Frame frame, String title, boolean modal, Map map, int type) {
		super(frame, title, modal);
		gui = (FuMuDbGUI) frame;
		this.map = map;
		this.type = type;
		this.formViewPerson = formViewPerson;

		createLayout();
		getContentPane().add(screenPanel);
		setDialog();
	}

	public ListDialog(FormViewBand formViewBand, Frame frame, String title, boolean modal, Map map, int type) {
		super(frame, title, modal);
		gui = (FuMuDbGUI) frame;
		this.map = map;
		this.type = type;
		this.formViewBand = formViewBand;

		createLayout();
		getContentPane().add(screenPanel);
		setDialog();
	}

	public ListDialog(FormViewRecord formViewRecord, Frame frame, String title, boolean modal, Map map, Map map1, int type) {
		super(frame, title, modal);
		gui = (FuMuDbGUI) frame;
		this.map = map;
		this.formViewRecord = formViewRecord;
		this.type = type;
		
		map.putAll(map1);

		createLayout();
		getContentPane().add(screenPanel);
		setDialog();
	}


	public void createLayout() {
		list.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		
		list.addMouseListener(new MouseAdapter() {
			public void mouseClicked(MouseEvent e) {
		        listItemClicked();
			}
		});
		
		gridbag = new GridBagLayout();
		GridBagConstraints gbc = new GridBagConstraints();
		infoPanel.setLayout(gridbag);
		gbc.weightx = 0;
		gbc.weighty = 0.5;
		
		Border blackline = BorderFactory.createEtchedBorder();
		infoPanel.setBorder(blackline);
		
		addToGBL(label1a, 0, 1, 1, 1, GridBagConstraints.HORIZONTAL);
		addToGBL(label1b, 1, 1, 1, 1, GridBagConstraints.HORIZONTAL);
		addToGBL(label2a, 0, 2, 1, 1, GridBagConstraints.HORIZONTAL);
		addToGBL(label2b, 1, 2, 1, 1, GridBagConstraints.HORIZONTAL);
		addToGBL(label3a, 0, 3, 1, 1, GridBagConstraints.HORIZONTAL);
		addToGBL(label3b, 1, 3, 1, 1, GridBagConstraints.HORIZONTAL);
		addToGBL(label4a, 0, 4, 1, 1, GridBagConstraints.HORIZONTAL);
		addToGBL(label4b, 1, 4, 1, 1, GridBagConstraints.HORIZONTAL);
		addToGBL(label5a, 0, 5, 1, 1, GridBagConstraints.HORIZONTAL);
		addToGBL(label5b, 1, 5, 1, 2, GridBagConstraints.HORIZONTAL);
		
		if (type == gui.BANDS) {
			createBandDialog();
		} else if (type == gui.MUSICIANS) {
			createMusicianDialog();
		} else if (type == gui.BANDS_MUSICIANS) {
			createMusicianAndBandDialog();
		} else if (type == gui.ARTIST_NAME) {
			createBandDialog();
		}
		
		Iterator it = map.keySet().iterator();
		while (it.hasNext()) {
   			String entry = (String) it.next();
	   		listModel.add(listModel.size(), entry);
		}

		scrollPane = new JScrollPane(list);
		screenPanel.setLayout(new BorderLayout());
		lowerPanel.setLayout(new BorderLayout());
		screenPanel.add(scrollPane, BorderLayout.CENTER);

		button1.setText("OK");
		button1.addActionListener(this);
		button2.addActionListener(this);
		
		buttonPanel.setLayout(new FlowLayout());
		buttonPanel.add(button1);
		buttonPanel.add(button2);
		if (!button3.getText().equals("")) {
			button3.addActionListener(this);
			buttonPanel.add(button3);
		}
		
		lowerPanel.add(infoPanel, BorderLayout.CENTER);
		lowerPanel.add(buttonPanel, BorderLayout.SOUTH);
		screenPanel.add(lowerPanel, BorderLayout.SOUTH);
	}
	
	public void createBandDialog() {
		button2.setText("neue Band / neuen Knstlernamen anlegen");
	}
	
	public void createMusicianDialog() {
		button2.setText("neuen Musiker anlegen");
	}

	public void createMusicianAndBandDialog() {
		button2.setText("neuen Musiker anlegen");
		button3.setText("neue Band / neuen Knstlernamen anlegen");
	}

	public void setDialog() {
		Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
		this.setSize(new Dimension(750, 400));
		this.setLocation((screenSize.width - 750)/2,(screenSize.height - 400)/2);
		this.setVisible(true);
		this.setResizable(false);
		this.validate();
	}
	
	public void listItemClicked() {
		MusicianInfoPanel infoPanel2 = new MusicianInfoPanel(gui, this, Integer.parseInt(map.get(list.getSelectedValue()).toString()));
		repaint();
	}
	
	public void addToGBL(Component c, int x, int y, 
			int width, int height, int fill) {
		GridBagConstraints gbc = new GridBagConstraints();
		gbc.gridy = y;
		gbc.gridx = x;		
		gbc.gridwidth = width;
		gbc.gridheight = height;
		gbc.insets = new Insets(0,0,4,10);
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gridbag.setConstraints(c, gbc);
		infoPanel.add(c);
	}

	public void actionPerformed(ActionEvent e) {
		if (e.getSource() == button1) {
			if (listModel.size()>0 && list.getSelectedIndex() != -1) {
				if (formViewRecord != null) {
					formViewRecord.fieldArtist.setText(list.getSelectedValue().toString());
					formViewRecord.musicianID = Integer.parseInt(map.get(list.getSelectedValue()).toString());
					MusicianInfoPanel infoPanel2 = new MusicianInfoPanel(gui, formViewRecord, Integer.parseInt(map.get(list.getSelectedValue()).toString()));
					this.dispose();
					formViewRecord.repaint();
					return;
				}
				if (formViewPerson != null) {
					if (type == gui.BANDS) {
						formViewPerson.bandListModel.add(0, list.getSelectedValue().toString());
						formViewPerson.newMemberships.add(list.getSelectedValue().toString());
						this.dispose();
						formViewPerson.repaint();
						return;
					} else if (type == gui.ARTIST_NAME) {
						formViewPerson.artistNameListModel.add(0, list.getSelectedValue().toString());
						formViewPerson.newMemberships.add(list.getSelectedValue().toString());
						this.dispose();
						formViewPerson.repaint();
						return;
					} 
				}
				if (formViewBand != null) {
					if (type == gui.MUSICIANS) {
						formViewBand.artistNameListModel.add(0, list.getSelectedValue().toString());
						this.dispose();
						formViewBand.repaint();
						return;
					} 
				}
			}
		}
		if (e.getSource() == button2) {
			if (type == gui.BANDS) {
				FormViewBand frame = new FormViewBand(gui, gui.getDesktopDimension(), "neue Band / neuer Knstlername"); 
				gui.addInternalFrameToVector(frame,"neue Band");
				gui.repaint();
				this.dispose();
				return;
			}
			if (type == gui.MUSICIANS || type == gui.BANDS_MUSICIANS) {
				FormViewPerson frame = new FormViewPerson(gui, gui.getDesktopDimension(), "neuer Musiker"); 
				gui.addInternalFrameToVector(frame,"neuer Musiker");
				gui.repaint();
				this.dispose();
				return;
			}
			return;
		}
		if (e.getSource() == button3) {
			if (type == gui.BANDS_MUSICIANS) {
				FormViewBand frame = new FormViewBand(gui, gui.getDesktopDimension(), "neue Band / neuer Knstlername"); 
				gui.addInternalFrameToVector(frame,"neue Band");
				gui.repaint();
				this.dispose();
				return;
			}
		}
	}
}
