package fumdb.gui;

import java.awt.Component;
import java.util.Vector;

import javax.swing.JPanel;

import fumdb.domain.Band;
import fumdb.domain.Member;
import fumdb.domain.Musician;
import fumdb.domain.Person;

/**
 * @author anja
 */
public class MusicianInfoPanel extends JPanel {
	public ListDialog listDialog;
	public FormViewRecord formViewRecord;
	public Musician musician;
	public Band band;
	public Person person;
	
	public MusicianInfoPanel(FuMuDbGUI gui, ListDialog listDialog, int id) {
		this.listDialog = listDialog;		

		musician = gui.getPersistence().getMusician(id);
		
		if (musician.isBand()) {
			band = (Band) musician;
			listDialog.label1a.setText("Band-/Knstlername : ");
			listDialog.label1b.setText(band.getName());
			listDialog.label2a.setText("URL : ");
			listDialog.label2b.setText(band.getURL());
			listDialog.label5a.setText("Mitglieder / Knstler : ");
			
			Vector memberships = band.getMembers();
			String memberNames = "";
			for (int i=0; i<memberships.size(); i++) {
				Person memberInfos = ((Member) memberships.get(i)).getPerson();
				memberNames += memberInfos.getName();
				if (i < memberships.size()-1) {
					memberNames += ", ";
				}
			}
			
			listDialog.label5b.setText(memberNames);
			listDialog.label3a.setText("");
			listDialog.label3b.setText("");
			listDialog.label4a.setText("");
			listDialog.label4b.setText("");
		} else {
			person = (Person) musician;
			listDialog.label1a.setText("Name : ");
			listDialog.label1b.setText(person.getName());
			listDialog.label2a.setText("URL : ");
			listDialog.label2b.setText(person.getURL());
			listDialog.label3a.setText("Geburtstag : ");
			if (person.getBirthday() != null) {
				listDialog.label3b.setText(person.getBirthday().toString());
			} else {
				listDialog.label3b.setText("");
			}
			listDialog.label4a.setText("Geschlecht : ");
			if (person.isMale()) {
				listDialog.label4b.setText("mnnlich");
			} else {
				listDialog.label4b.setText("weiblich");
			}

			Vector memberships = person.getBandMemberships();
			String memberNames = "";
			for (int i=0; i<memberships.size(); i++) {
				Band memberInfos = ((Member) memberships.get(i)).getBand();
				memberNames += memberInfos.getName();
				if (i < memberships.size()-1) {
					memberNames += ", ";
				}
				if (i == 3) {
					memberNames += "\n";
				}
			}
			listDialog.label5b.setText(memberNames);
			if (!memberNames.equals("")) {
				listDialog.label5a.setText("Bandmitgliedschaften/Knstlernamen:");
			} else {
				listDialog.label5a.setText("");
			}
		}
		
	}

	public MusicianInfoPanel(FuMuDbGUI gui, FormViewRecord formViewRecord, int id) {
		this.formViewRecord = formViewRecord;		
		musician = gui.getPersistence().getMusician(id);
		
		if (musician.isBand()) {
			band = (Band) musician;
			formViewRecord.label1a.setText("Band-/Knstlername : ");
			formViewRecord.label1b.setText(band.getName());
			formViewRecord.label2a.setText("URL : ");
			formViewRecord.label2b.setText(band.getURL());
			formViewRecord.label5a.setText("Mitglieder / Knstler : ");
			
			Vector memberships = band.getMembers();
			String memberNames = "";
			for (int i=0; i<memberships.size(); i++) {
				Person memberInfos = ((Member) memberships.get(i)).getPerson();
				memberNames += memberInfos.getName();
				if (i < memberships.size()-1) {
					memberNames += ", ";
				}
			}
			formViewRecord.label5b.setText(memberNames);
			formViewRecord.label3a.setText("");
			formViewRecord.label3b.setText("");
			formViewRecord.label4a.setText("");
			formViewRecord.label4b.setText("");
		} else {
			person = (Person) musician;
			formViewRecord.label1a.setText("Name : ");
			formViewRecord.label1b.setText(person.getName());
			formViewRecord.label2a.setText("URL : ");
			formViewRecord.label2b.setText(person.getURL());
			formViewRecord.label3a.setText("Geburtstag : ");
			if (person.getBirthday() != null) {
				formViewRecord.label3b.setText(person.getBirthday().toString());
			} else {
				formViewRecord.label3b.setText("");
			}
			formViewRecord.label4a.setText("Geschlecht : ");
			if (person.isMale()) {
				formViewRecord.label4b.setText("mnnlich");
			} else {
				formViewRecord.label4b.setText("weiblich");
			}
		
			Vector memberships = person.getBandMemberships();
			String memberNames = "";
			for (int i=0; i<memberships.size(); i++) {
				Band memberInfos = ((Member) memberships.get(i)).getBand();
				memberNames += memberInfos.getName();
				if (i < memberships.size()-1) {
					memberNames += ", ";
				}
			}
			formViewRecord.label5b.setText(memberNames);
			if (!memberNames.equals("")) {
				formViewRecord.label5a.setText("Bandmitgliedschaften/Knstlernamen:");
			} else {
				formViewRecord.label5a.setText("");
			}
		}
		
	}


}
