package fumdb.gui;

import java.awt.Color;
import java.awt.Dimension;

import javax.swing.ImageIcon;
import javax.swing.JInternalFrame;

/**
 * @author anja
 */

public abstract class View extends JInternalFrame {
	String title = ""; 
	Dimension size;
	boolean resizable = false; 
	boolean closable = true; 
	boolean maximizable = false; 
	boolean iconifiable = false; 
	ImageIcon search = new ImageIcon(getClass().getResource("search_icon.gif").getFile());
	ImageIcon query = new ImageIcon(getClass().getResource("query_icon.gif").getFile());
	
	public View(Dimension size, String title) {
		this.title = title;
		this.size = size;
		createFrame();
	}

	protected void createFrame() { 
		this.setSize(size); 
		this.setTitle(title);
		this.setLocation(0,0); 
		this.setBackground(Color.WHITE);
		this.setResizable(false);
		this.setClosable(true);
		this.setMaximizable(false);
		this.setIconifiable(false);

		setFrameIcon(getIcon());
	} 

	protected abstract ImageIcon getIcon();
	
	public Dimension getPreferredSize() {
		return size;
	}
	
	public Dimension getMinimumSize() {
		return size;
	}
	
	public Dimension getMaximumSize() {
		return size;
	}
}
