package fumdb.servlet;

import java.io.PrintWriter;
import java.sql.SQLException;

/**
 * @author Richard Cyganiak
 */
public class DatabaseErrorPage extends HtmlPage {

	private SQLException error;

	public DatabaseErrorPage(SQLException error) {
		this.error = error;
	}

	protected String getTitle() {
		return "Datenbankfehler";
	}

	protected String getHeadline() {
		return "<h1>Ein Datenbankfehler ist aufgetreten.</h1>";
	}

	protected void printBody() {
		out("<p><strong>Fehler</strong>: " + error.getMessage() + "</p>");
		out("<p><strong>SQL-Fehlercode</strong>: " + error.getErrorCode() + "</p>");	
	}
}
