package fumdb.servlet;

import java.io.PrintWriter;
import java.sql.SQLException;

import fumdb.sql.SQLErrorListener;

/**
 * @author Richard Cyganiak
 */
public class ServletErrorListener implements SQLErrorListener {

	private PrintWriter out;
	private boolean isError = false;

	public void setPrintWriter(PrintWriter pw) {
		this.out = pw;
	}

	/**
	 * @see fumdb.sql.SQLErrorListener#catchSQLException(SQLException)
	 */
	public void catchSQLException(SQLException e) {
		isError = true;
		HtmlPage page = new DatabaseErrorPage(e);
		page.send(out);
	}
	
	public void setError(boolean isError) {
		this.isError = isError;
	}
	
	public boolean isError() {
		return isError;
	}
}
